Index: /pjproject/trunk/pjmedia/build/pjmedia_codec.dsp
===================================================================
--- /pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 182)
+++ /pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 183)
@@ -42,5 +42,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /W4 /GX /O2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /YX /FD /c
+# ADD CPP /nologo /MD /W4 /GX /O2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
Index: /pjproject/trunk/pjmedia/src/pjmedia/errno.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 183)
@@ -127,5 +127,5 @@
 	    
 	    msg.ptr = (char*)err_str[first].msg;
-	    msg.slen = pj_native_strlen(err_str[first].msg);
+	    msg.slen = pj_ansi_strlen(err_str[first].msg);
 
 	    errstr.ptr = buf;
Index: /pjproject/trunk/pjmedia/src/pjmedia/portaudio/dsound_wrapper.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/portaudio/dsound_wrapper.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/portaudio/dsound_wrapper.c	(revision 183)
@@ -96,13 +96,18 @@
     return E_NOTIMPL;
 }
+
+#ifndef _T
+#   define _T(s)    s
+#endif
+
 /************************************************************************************/
 void DSW_InitializeDSoundEntryPoints(void)
 {
-    dswDSoundEntryPoints.hInstance_ = LoadLibrary("dsound.dll");
+    dswDSoundEntryPoints.hInstance_ = LoadLibrary(_T("dsound.dll"));
     if( dswDSoundEntryPoints.hInstance_ != NULL )
     {
         dswDSoundEntryPoints.DirectSoundCreate =
                 (HRESULT (WINAPI *)(LPGUID, LPDIRECTSOUND *, LPUNKNOWN))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundCreate" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundCreate") );
         if( dswDSoundEntryPoints.DirectSoundCreate == NULL )
             dswDSoundEntryPoints.DirectSoundCreate = DummyDirectSoundCreate;
@@ -110,5 +115,5 @@
         dswDSoundEntryPoints.DirectSoundEnumerateW =
                 (HRESULT (WINAPI *)(LPDSENUMCALLBACKW, LPVOID))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundEnumerateW" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundEnumerateW") );
         if( dswDSoundEntryPoints.DirectSoundEnumerateW == NULL )
             dswDSoundEntryPoints.DirectSoundEnumerateW = DummyDirectSoundEnumerateW;
@@ -116,5 +121,5 @@
         dswDSoundEntryPoints.DirectSoundEnumerateA =
                 (HRESULT (WINAPI *)(LPDSENUMCALLBACKA, LPVOID))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundEnumerateA" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundEnumerateA") );
         if( dswDSoundEntryPoints.DirectSoundEnumerateA == NULL )
             dswDSoundEntryPoints.DirectSoundEnumerateA = DummyDirectSoundEnumerateA;
@@ -122,5 +127,5 @@
         dswDSoundEntryPoints.DirectSoundCaptureCreate =
                 (HRESULT (WINAPI *)(LPGUID, LPDIRECTSOUNDCAPTURE *, LPUNKNOWN))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundCaptureCreate" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundCaptureCreate") );
         if( dswDSoundEntryPoints.DirectSoundCaptureCreate == NULL )
             dswDSoundEntryPoints.DirectSoundCaptureCreate = DummyDirectSoundCaptureCreate;
@@ -128,5 +133,5 @@
         dswDSoundEntryPoints.DirectSoundCaptureEnumerateW =
                 (HRESULT (WINAPI *)(LPDSENUMCALLBACKW, LPVOID))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundCaptureEnumerateW" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundCaptureEnumerateW") );
         if( dswDSoundEntryPoints.DirectSoundCaptureEnumerateW == NULL )
             dswDSoundEntryPoints.DirectSoundCaptureEnumerateW = DummyDirectSoundCaptureEnumerateW;
@@ -134,5 +139,5 @@
         dswDSoundEntryPoints.DirectSoundCaptureEnumerateA =
                 (HRESULT (WINAPI *)(LPDSENUMCALLBACKA, LPVOID))
-                GetProcAddress( dswDSoundEntryPoints.hInstance_, "DirectSoundCaptureEnumerateA" );
+                GetProcAddress( dswDSoundEntryPoints.hInstance_, _T("DirectSoundCaptureEnumerateA") );
         if( dswDSoundEntryPoints.DirectSoundCaptureEnumerateA == NULL )
             dswDSoundEntryPoints.DirectSoundCaptureEnumerateA = DummyDirectSoundCaptureEnumerateA;
Index: /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_ds.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_ds.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_ds.c	(revision 183)
@@ -68,5 +68,4 @@
 #include "pa_cpuload.h"
 #include "pa_process.h"
-
 #include "dsound_wrapper.h"
 
@@ -76,4 +75,6 @@
 #endif
 
+
+#include <pj/unicode.h>
 
 #define PRINT(x) /* { printf x; fflush(stdout); } */
@@ -326,4 +327,5 @@
     DSDeviceNameAndGUIDVector *namesAndGUIDs = (DSDeviceNameAndGUIDVector*)lpContext;
     PaError error;
+    PJ_DECL_ANSI_TEMP_BUF(atemp,128)
 
     (void) lpszDrvName; /* unused variable */
@@ -353,5 +355,6 @@
 
     namesAndGUIDs->items[namesAndGUIDs->count].name =
-            DuplicateDeviceNameString( namesAndGUIDs->allocations, lpszDesc );
+            DuplicateDeviceNameString( namesAndGUIDs->allocations, 
+	    PJ_NATIVE_TO_STRING(lpszDesc,atemp,sizeof(atemp)));
     if( namesAndGUIDs->items[namesAndGUIDs->count].name == NULL )
     {
@@ -1024,5 +1027,9 @@
 
     /* Let user determine minimal latency by setting environment variable. */
+#ifdef UNDER_CE
+    hresult = 0;
+#else
     hresult = GetEnvironmentVariable( PA_LATENCY_ENV_NAME, envbuf, PA_ENV_BUF_SIZE );
+#endif
     if( (hresult > 0) && (hresult < PA_ENV_BUF_SIZE) )
     {
Index: /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_util.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_util.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_util.c	(revision 183)
@@ -129,5 +129,9 @@
     else
     {
+#ifndef UNDER_CE
         return timeGetTime() * .001;
+#else
+	return GetTickCount() * .001;
+#endif
     }
 }
Index: /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_wmme.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_wmme.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/portaudio/pa_win_wmme.c	(revision 183)
@@ -106,5 +106,7 @@
 #include <windows.h>
 #include <mmsystem.h>
+#ifndef UNDER_CE
 #include <process.h>
+#endif
 #include <assert.h>
 /* PLB20010422 - "memory.h" doesn't work on CodeWarrior for PC. Thanks Mike Berry for the mod. */
@@ -125,5 +127,10 @@
 #include "pa_win_wmme.h"
 
-#if (defined(WIN32) && (defined(_MSC_VER) && (_MSC_VER >= 1200))) /* MSC version 6 and above */
+#include <pj/string.h>
+#include <pj/unicode.h>
+
+#if (defined(WIN32) && (defined(_MSC_VER) && (_MSC_VER >= 1200))) && \
+    !defined(UNDER_CE)
+/* MSC version 6 and above */
 #pragma comment(lib, "winmm.lib")
 #endif
@@ -160,6 +167,6 @@
 #define PA_MME_MIN_TIMEOUT_MSEC_        (1000)
 
-static const char constInputMapperSuffix_[] = " - Input";
-static const char constOutputMapperSuffix_[] = " - Output";
+static const pj_char_t constInputMapperSuffix_[] = PJ_T(" - Input");
+static const pj_char_t constOutputMapperSuffix_[] = PJ_T(" - Output");
 
 /********************************************************************/
@@ -553,4 +560,5 @@
     WAVEINCAPS wic;
     PaDeviceInfo *deviceInfo = &winMmeDeviceInfo->inheritedDeviceInfo;
+    PJ_DECL_ANSI_TEMP_BUF(abuf,128)
     
     *success = 0;
@@ -575,6 +583,7 @@
     {
         /* Append I/O suffix to WAVE_MAPPER device. */
-        deviceName = (char *)PaUtil_GroupAllocateMemory(
-                    winMmeHostApi->allocations, strlen( wic.szPname ) + 1 + sizeof(constInputMapperSuffix_) );
+        deviceName = (char*)PaUtil_GroupAllocateMemory(
+                    winMmeHostApi->allocations, 
+		    pj_native_strlen( wic.szPname ) + sizeof(pj_char_t) + sizeof(constInputMapperSuffix_) );
         if( !deviceName )
         {
@@ -582,11 +591,11 @@
             goto error;
         }
-        strcpy( deviceName, wic.szPname );
-        strcat( deviceName, constInputMapperSuffix_ );
+        strcpy( deviceName, PJ_NATIVE_TO_STRING(wic.szPname,abuf,sizeof(abuf)) );
+        strcat( deviceName, PJ_NATIVE_TO_STRING(constInputMapperSuffix_,abuf,sizeof(abuf)) );
     }
     else
     {
         deviceName = (char*)PaUtil_GroupAllocateMemory(
-                    winMmeHostApi->allocations, strlen( wic.szPname ) + 1 );
+                    winMmeHostApi->allocations, pj_native_strlen( wic.szPname ) + sizeof(pj_char_t) );
         if( !deviceName )
         {
@@ -594,5 +603,5 @@
             goto error;
         }
-        strcpy( deviceName, wic.szPname  );
+        strcpy( deviceName, PJ_NATIVE_TO_STRING(wic.szPname,abuf,sizeof(abuf))  );
     }
     deviceInfo->name = deviceName;
@@ -629,4 +638,5 @@
     WAVEOUTCAPS woc;
     PaDeviceInfo *deviceInfo = &winMmeDeviceInfo->inheritedDeviceInfo;
+    PJ_DECL_ANSI_TEMP_BUF(abuf,128)
     
     *success = 0;
@@ -652,5 +662,5 @@
         /* Append I/O suffix to WAVE_MAPPER device. */
         deviceName = (char *)PaUtil_GroupAllocateMemory(
-                    winMmeHostApi->allocations, strlen( woc.szPname ) + 1 + sizeof(constOutputMapperSuffix_) );
+                    winMmeHostApi->allocations, pj_native_strlen( woc.szPname ) + 1 + sizeof(constOutputMapperSuffix_) );
         if( !deviceName )
         {
@@ -658,11 +668,11 @@
             goto error;
         }
-        strcpy( deviceName, woc.szPname );
-        strcat( deviceName, constOutputMapperSuffix_ );
+        strcpy( deviceName, PJ_NATIVE_TO_STRING(woc.szPname,abuf,sizeof(abuf)) );
+        strcat( deviceName, PJ_NATIVE_TO_STRING(constOutputMapperSuffix_,abuf,sizeof(abuf)) );
     }
     else
     {
         deviceName = (char*)PaUtil_GroupAllocateMemory(
-                    winMmeHostApi->allocations, strlen( woc.szPname ) + 1 );
+                    winMmeHostApi->allocations, pj_native_strlen( woc.szPname ) + 1 );
         if( !deviceName )
         {
@@ -670,5 +680,5 @@
             goto error;
         }
-        strcpy( deviceName, woc.szPname  );
+        strcpy( deviceName, PJ_NATIVE_TO_STRING(woc.szPname,abuf,sizeof(abuf))  );
     }
     deviceInfo->name = deviceName;
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 182)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 183)
@@ -169,5 +169,5 @@
 
     name.ptr = (char*)c_name;
-    name.slen = pj_native_strlen(c_name);
+    name.slen = pj_ansi_strlen(c_name);
 
     return pjmedia_sdp_attr_find(count, attr_array, &name, c_fmt);
@@ -199,5 +199,5 @@
 
     attr_name.ptr = (char*)name;
-    attr_name.slen = pj_native_strlen(name);
+    attr_name.slen = pj_ansi_strlen(name);
 
     for (i=0; i<*count; ) {
